exec("./prefs.cs");
$brickTes::fileObject = new FileObject();
function generateTesBricks()
{
	%count = DataBlockGroup.getCount();
	for(%a=0;%a<%count;%a++)
	{
		%b = DataBlockGroup.getObject(%a);
		if($brickTes::Mode)
		{
			if(%b.getClassName() $= "fxDTSBrickData")
			{
				%c = 1;
				if(isFile(%b.brickFile))
				{
					%f = $brickTes::fileObject;
					%f.openForRead(%b.brickFile);
					%l1=%f.readLine();
					%l2=%f.readLine();
					%f.close();
					if(%l2 $= "SPECIALBRICK" || %l2 $= "SPECIAL")
					{
						if($brickTes::Mode > 1 && !isFile(%b.collisionShapeName))
						{
							%n = %l2 @"/"@ fileBase(%b.brickFile);
							generateTesBrick(%l1,%n);
							%b.brickFile = $brickTes::brickPath @ %n @".blb";
						}
					}
					else
					{
						%n = %l2 @"/"@ fileBase(%b.brickFile);
						generateTesBrick(%l1,%n);
						%b.brickFile = $brickTes::brickPath @ %n @".blb";
					}
				}
				else
				{
					%l1 = %b.brickSizeX SPC %b.brickSizeY SPC %b.brickSizeZ;
					%n = "NOBRICK/"@ %b.uiName;
					generateTesBrick(%l1,%n);
					%b.brickFile = $brickTes::brickPath @ %n @".blb";
				}
			}
		}
	}
}
package brickTesServer
{
	function fxDTSBrickData::onAdd(%data)
	{
		parent::onAdd(%data);
		if($brickTes::Enable)
		{
			%b = %data;
			if(isFile(%b.brickFile))
			{
				%f = $brickTes::fileObject;
				%f.openForRead(%b.brickFile);
				%l1=%f.readLine();
				%l2=%f.readLine();
				%f.close();
				if(%l2 $= "SPECIALBRICK" || %l2 $= "SPECIAL")
				{
					if($brickTes::SpecialMode && !isFile(%b.collisionShapeName))
					{
						%n = %l2 @"/"@ fileBase(%b.brickFile);
						generateTesBrick(%l1,%n);
						%b.brickFile = $brickTes::brickPath @ %n @".blb";
					}
				}
				else if(%l2 $= "BRICK")
				{
					%n = %l2 @"/"@ fileBase(%b.brickFile);
					generateTesBrick(%l1,%n);
					%b.brickFile = $brickTes::brickPath @ %n @".blb";
				}
			}
			else
			{
				%l1 = %b.brickSizeX SPC %b.brickSizeY SPC %b.brickSizeZ;
				%n = "NOBRICK/"@ %b.uiName;
				generateTesBrick(%l1,%n);
				%b.brickFile = $brickTes::brickPath @ %n @".blb";
			}
		}
	}
};
activatePackage(brickTesServer);
function generateTesBrick(%scale,%name)
{
	%file = new FileObject();
	%file.openForWrite($brickTes::brickPath @ %name @".blb");
	%sizex = getWord(%scale,0);
	%sizey = getWord(%scale,1);
	%sizez = getWord(%scale,2);
	%top = %sizez/2;
	%bottom = %top*-1;
	%north = %sizey/2;
	%south = %north*-1;
	%east = %sizex/2;
	%west = %east*-1;
	%file.writeLine(%scale);
	%file.writeLine("SPECIALBRICK");
	%file.writeLine("");
	%file.writeLine("1");
	%file.writeLine("");
	%file.writeLine("0 0 0");
	%file.writeLine(%scale);
	%topquads = %sizex*%sizey*5;
	%sidequads = 1+$brickTes::SideMode*19;
	%bottomquads = 1+$brickTes::DoBottom*4;
	%file.writeLine("----------------TOPQUADS");
	switch($brickTes::TopMode)
	{
		case 0:
			%file.writeLine("1");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%west SPC %south SPC %top);
			%file.writeLine(%west SPC %north SPC %top);
			%file.writeLine(%east SPC %north SPC %top);
			%file.writeLine(%east SPC %south SPC %top);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 0 1");
			%file.writeLine("0 0 1");
			%file.writeLine("0 0 1");
			%file.writeLine("0 0 1");
		case 1:
			%file.writeLine("1");
			%file.writeLine("");
			%file.writeLine("TEX:TOP");
			%file.writeLine("POSITION:");
			%file.writeLine(%west SPC %south SPC %top);
			%file.writeLine(%west SPC %north SPC %top);
			%file.writeLine(%east SPC %north SPC %top);
			%file.writeLine(%east SPC %south SPC %top);
			%file.writeLine("UV COORDS:");
			%file.writeLine(%sizex @" 0");
			%file.writeLine(%sizex SPC %sizey);
			%file.writeLine("0 "@ %sizey);
			%file.writeLine("0 0");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 0 1");
			%file.writeLine("0 0 1");
			%file.writeLine("0 0 1");
			%file.writeLine("0 0 1");
		case 2:
			if(%topquads < 512-(%sidequads+%bottomquads))
			{
				%file.writeLine(%topquads);
				%tesTop = %top+$brickTes::TopDepth;
				for(%x=0;%x<%sizex;%x++)
				{
					for(%y=0;%y<%sizey;%y++)
					{
						%p0 = %west+%x SPC %south+%y SPC %top;
						%p1 = %west+%x SPC %south+%y+1 SPC %top;
						%p2 = %west+%x+1 SPC %south+%y+1 SPC %top;
						%p3 = %west+%x+1 SPC %south+%y SPC %top;
						%p4 = %west+%x+$brickTes::TopInset SPC %south+%y+$brickTes::TopInset SPC %tesTop;
						%p5 = %west+%x+$brickTes::TopInset SPC %south+%y+(1-$brickTes::TopInset) SPC %tesTop;
						%p6 = %west+%x+(1-$brickTes::TopInset) SPC %south+%y+(1-$brickTes::TopInset) SPC %tesTop;
						%p7 = %west+%x+(1-$brickTes::TopInset) SPC %south+%y+$brickTes::TopInset SPC %tesTop;

						%file.writeLine("");
						%file.writeLine("TEX:SIDE");
						%file.writeLine("POSITION:");
						%file.writeLine(%p4);
						%file.writeLine(%p5);
						%file.writeLine(%p6);
						%file.writeLine(%p7);
						%file.writeLine("UV COORDS:");
						%file.writeLine("0.8 0.2");
						%file.writeLine("0.8 0.8");
						%file.writeLine("0.2 0.8");
						%file.writeLine("0.2 0.2");
						%file.writeLine("NORMALS:");
						%file.writeLine("0 0 1");
						%file.writeLine("0 0 1");
						%file.writeLine("0 0 1");
						%file.writeLine("0 0 1");
						%file.writeLine("");
						%file.writeLine("TEX:SIDE");
						%file.writeLine("POSITION:");
						%file.writeLine(%p5);
						%file.writeLine(%p1);
						%file.writeLine(%p2);
						%file.writeLine(%p6);
						%file.writeLine("UV COORDS:");
						%file.writeLine("0.8 0.2");
						%file.writeLine("0.8 0.8");
						%file.writeLine("0.2 0.8");
						%file.writeLine("0.2 0.2");
						%file.writeLine("NORMALS:");
						%file.writeLine("0 0.4 0.6");
						%file.writeLine("0 0.4 0.6");
						%file.writeLine("0 0.4 0.6");
						%file.writeLine("0 0.4 0.6");
						%file.writeLine("");
						%file.writeLine("TEX:SIDE");
						%file.writeLine("POSITION:");
						%file.writeLine(%p7);
						%file.writeLine(%p6);
						%file.writeLine(%p2);
						%file.writeLine(%p3);
						%file.writeLine("UV COORDS:");
						%file.writeLine("0.8 0.2");
						%file.writeLine("0.8 0.8");
						%file.writeLine("0.2 0.8");
						%file.writeLine("0.2 0.2");
						%file.writeLine("NORMALS:");
						%file.writeLine("0.4 0 0.6");
						%file.writeLine("0.4 0 0.6");
						%file.writeLine("0.4 0 0.6");
						%file.writeLine("0.4 0 0.6");
						%file.writeLine("");
						%file.writeLine("TEX:SIDE");
						%file.writeLine("POSITION:");
						%file.writeLine(%p0);
						%file.writeLine(%p4);
						%file.writeLine(%p7);
						%file.writeLine(%p3);
						%file.writeLine("UV COORDS:");
						%file.writeLine("0.8 0.2");
						%file.writeLine("0.8 0.8");
						%file.writeLine("0.2 0.8");
						%file.writeLine("0.2 0.2");
						%file.writeLine("NORMALS:");
						%file.writeLine("0 -0.4 0.6");
						%file.writeLine("0 -0.4 0.6");
						%file.writeLine("0 -0.4 0.6");
						%file.writeLine("0 -0.4 0.6");
						%file.writeLine("");
						%file.writeLine("TEX:SIDE");
						%file.writeLine("POSITION:");
						%file.writeLine(%p0);
						%file.writeLine(%p1);
						%file.writeLine(%p5);
						%file.writeLine(%p4);
						%file.writeLine("UV COORDS:");
						%file.writeLine("0.8 0.2");
						%file.writeLine("0.8 0.8");
						%file.writeLine("0.2 0.8");
						%file.writeLine("0.2 0.2");
						%file.writeLine("NORMALS:");
						%file.writeLine("-0.4 0 0.6");
						%file.writeLine("-0.4 0 0.6");
						%file.writeLine("-0.4 0 0.6");
						%file.writeLine("-0.4 0 0.6");
					}
				}
			}
			else
			{
				%file.writeLine("1");
				%file.writeLine("");
				%file.writeLine("TEX:TOP");
				%file.writeLine("POSITION:");
				%file.writeLine(%west SPC %south SPC %top);
				%file.writeLine(%west SPC %north SPC %top);
				%file.writeLine(%east SPC %north SPC %top);
				%file.writeLine(%east SPC %south SPC %top);
				%file.writeLine("UV COORDS:");
				%file.writeLine(%sizex @" 0");
				%file.writeLine(%sizex SPC %sizey);
				%file.writeLine("0 "@ %sizey);
				%file.writeLine("0 0");
				%file.writeLine("NORMALS:");
				%file.writeLine("0 0 1");
				%file.writeLine("0 0 1");
				%file.writeLine("0 0 1");
				%file.writeLine("0 0 1");
			}
	}
	%file.writeLine("----------------BOTTOMQUADS");
	switch($brickTes::BottomMode)
	{
		case 0:
			%file.writeLine("1");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%west SPC %north SPC %bottom);
			%file.writeLine(%west SPC %south SPC %bottom);
			%file.writeLine(%east SPC %south SPC %bottom);
			%file.writeLine(%east SPC %north SPC %bottom);
			%file.writeLine("UV COORDS:");
			%file.writeLine(%sizex @" 0");
			%file.writeLine(%sizex SPC %sizey);
			%file.writeLine("0 "@ %sizey);
			%file.writeLine("0 0");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
		case 1:
			%file.writeLine("1");
			%file.writeLine("");
			%file.writeLine("TEX:BOTTOMLOOP");
			%file.writeLine("POSITION:");
			%file.writeLine(%west SPC %north SPC %bottom);
			%file.writeLine(%west SPC %south SPC %bottom);
			%file.writeLine(%east SPC %south SPC %bottom);
			%file.writeLine(%east SPC %north SPC %bottom);
			%file.writeLine("UV COORDS:");
			%file.writeLine(%sizex @" 0");
			%file.writeLine(%sizex SPC %sizey);
			%file.writeLine("0 "@ %sizey);
			%file.writeLine("0 0");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
		case 2:
			%file.writeLine("9");
			%tesbottom = %bottom+$brickTes::BottomDepth;
			%p0 = %west SPC %north SPC %bottom;
			%p1 = %west SPC %south SPC %bottom;
			%p2 = %east SPC %south SPC %bottom;
			%p3 = %east SPC %north SPC %bottom;

			%p4 = %west+$brickTes::BottomInset SPC %north-$brickTes::BottomInset SPC %bottom;
			%p5 = %west+$brickTes::BottomInset SPC %south+$brickTes::BottomInset SPC %bottom;
			%p6 = %east-$brickTes::BottomInset SPC %south+$brickTes::BottomInset SPC %bottom;
			%p7 = %east-$brickTes::BottomInset SPC %north-$brickTes::BottomInset SPC %bottom;

			%p8 = %west+$brickTes::BottomInset SPC %north-$brickTes::BottomInset SPC %tesBottom;
			%p9 = %west+$brickTes::BottomInset SPC %south+$brickTes::BottomInset SPC %tesBottom;
			%p10 = %east-$brickTes::BottomInset SPC %south+$brickTes::BottomInset SPC %tesBottom;
			%p11 = %east-$brickTes::BottomInset SPC %north-$brickTes::BottomInset SPC %tesBottom;

			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%p0);
			%file.writeLine(%p1);
			%file.writeLine(%p5);
			%file.writeLine(%p4);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%p4);
			%file.writeLine(%p5);
			%file.writeLine(%p9);
			%file.writeLine(%p8);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("1 0 0");
			%file.writeLine("1 0 0");
			%file.writeLine("1 0 0");
			%file.writeLine("1 0 0");

			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%p5);
			%file.writeLine(%p1);
			%file.writeLine(%p2);
			%file.writeLine(%p6);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%p9);
			%file.writeLine(%p5);
			%file.writeLine(%p6);
			%file.writeLine(%p10);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 1 0");
			%file.writeLine("0 1 0");
			%file.writeLine("0 1 0");
			%file.writeLine("0 1 0");

			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%p7);
			%file.writeLine(%p6);
			%file.writeLine(%p2);
			%file.writeLine(%p3);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%p11);
			%file.writeLine(%p10);
			%file.writeLine(%p6);
			%file.writeLine(%p7);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("-1 0 0");
			%file.writeLine("-1 0 0");
			%file.writeLine("-1 0 0");
			%file.writeLine("-1 0 0");

			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%p0);
			%file.writeLine(%p4);
			%file.writeLine(%p7);
			%file.writeLine(%p3);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%p4);
			%file.writeLine(%p8);
			%file.writeLine(%p11);
			%file.writeLine(%p7);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 -1 0");
			%file.writeLine("0 -1 0");
			%file.writeLine("0 -1 0");
			%file.writeLine("0 -1 0");

			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%p8);
			%file.writeLine(%p9);
			%file.writeLine(%p10);
			%file.writeLine(%p11);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
		case 3:
			%file.writeLine("9");
			%tesbottom = %bottom+$brickTes::BottomDepth;
			%p0 = %west SPC %north SPC %bottom;
			%p1 = %west SPC %south SPC %bottom;
			%p2 = %east SPC %south SPC %bottom;
			%p3 = %east SPC %north SPC %bottom;

			%p4 = %west+$brickTes::BottomInset SPC %north-$brickTes::BottomInset SPC %bottom;
			%p5 = %west+$brickTes::BottomInset SPC %south+$brickTes::BottomInset SPC %bottom;
			%p6 = %east-$brickTes::BottomInset SPC %south+$brickTes::BottomInset SPC %bottom;
			%p7 = %east-$brickTes::BottomInset SPC %north-$brickTes::BottomInset SPC %bottom;

			%p8 = %west+$brickTes::BottomInset SPC %north-$brickTes::BottomInset SPC %tesBottom;
			%p9 = %west+$brickTes::BottomInset SPC %south+$brickTes::BottomInset SPC %tesBottom;
			%p10 = %east-$brickTes::BottomInset SPC %south+$brickTes::BottomInset SPC %tesBottom;
			%p11 = %east-$brickTes::BottomInset SPC %north-$brickTes::BottomInset SPC %tesBottom;

			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%p0);
			%file.writeLine(%p1);
			%file.writeLine(%p5);
			%file.writeLine(%p4);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%p4);
			%file.writeLine(%p5);
			%file.writeLine(%p9);
			%file.writeLine(%p8);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("1 0 0");
			%file.writeLine("1 0 0");
			%file.writeLine("1 0 0");
			%file.writeLine("1 0 0");

			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%p5);
			%file.writeLine(%p1);
			%file.writeLine(%p2);
			%file.writeLine(%p6);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%p9);
			%file.writeLine(%p5);
			%file.writeLine(%p6);
			%file.writeLine(%p10);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 1 0");
			%file.writeLine("0 1 0");
			%file.writeLine("0 1 0");
			%file.writeLine("0 1 0");

			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%p7);
			%file.writeLine(%p6);
			%file.writeLine(%p2);
			%file.writeLine(%p3);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%p11);
			%file.writeLine(%p10);
			%file.writeLine(%p6);
			%file.writeLine(%p7);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("-1 0 0");
			%file.writeLine("-1 0 0");
			%file.writeLine("-1 0 0");
			%file.writeLine("-1 0 0");

			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%p0);
			%file.writeLine(%p4);
			%file.writeLine(%p7);
			%file.writeLine(%p3);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%p4);
			%file.writeLine(%p8);
			%file.writeLine(%p11);
			%file.writeLine(%p7);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 -1 0");
			%file.writeLine("0 -1 0");
			%file.writeLine("0 -1 0");
			%file.writeLine("0 -1 0");

			%file.writeLine("");
			%file.writeLine("TEX:BOTTOMLOOP");
			%file.writeLine("POSITION:");
			%file.writeLine(%p8);
			%file.writeLine(%p9);
			%file.writeLine(%p10);
			%file.writeLine(%p11);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0 0");
			%file.writeLine("0 "@ %sizey-1);
			%file.writeLine(%sizex-1 SPC %sizey-1);
			%file.writeLine(%sizex-1 @" 0");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
			%file.writeLine("0 0 -1");
	}
	switch($brickTes::SideMode)
	{
		case 0:
			%file.writeLine("----------------NORTHQUADS");
			%file.writeLine("1");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%east SPC %north SPC %bottom);
			%file.writeLine(%east SPC %north SPC %top);
			%file.writeLine(%west SPC %north SPC %top);
			%file.writeLine(%west SPC %north SPC %bottom);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 1 0");
			%file.writeLine("0 1 0");
			%file.writeLine("0 1 0");
			%file.writeLine("0 1 0");
			%file.writeLine("----------------EASTQUADS");
			%file.writeLine("1");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%east SPC %south SPC %bottom);
			%file.writeLine(%east SPC %south SPC %top);
			%file.writeLine(%east SPC %north SPC %top);
			%file.writeLine(%east SPC %north SPC %bottom);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("1 0 0");
			%file.writeLine("1 0 0");
			%file.writeLine("1 0 0");
			%file.writeLine("1 0 0");
			%file.writeLine("----------------SOUTHQUADS");
			%file.writeLine("1");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%west SPC %south SPC %bottom);
			%file.writeLine(%west SPC %south SPC %top);
			%file.writeLine(%east SPC %south SPC %top);
			%file.writeLine(%east SPC %south SPC %bottom);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 -1 0");
			%file.writeLine("0 -1 0");
			%file.writeLine("0 -1 0");
			%file.writeLine("0 -1 0");
			%file.writeLine("----------------WESTQUADS");
			%file.writeLine("1");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%west SPC %north SPC %bottom);
			%file.writeLine(%west SPC %north SPC %top);
			%file.writeLine(%west SPC %south SPC %top);
			%file.writeLine(%west SPC %south SPC %bottom);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("-1 0 0");
			%file.writeLine("-1 0 0");
			%file.writeLine("-1 0 0");
			%file.writeLine("-1 0 0");
		case 1:
			%n0 = %east SPC %north SPC %bottom;
			%n1 = %east SPC %north SPC %top;
			%n2 = %west SPC %north SPC %top;
			%n3 = %west SPC %north SPC %bottom;
			%n4 = %east-$brickTes::SideInset SPC %north+$brickTes::SideDepth SPC %bottom+$brickTes::SideInset;
			%n5 = %east-$brickTes::SideInset SPC %north+$brickTes::SideDepth SPC %top-$brickTes::SideInset;
			%n6 = %west+$brickTes::SideInset SPC %north+$brickTes::SideDepth SPC %top-$brickTes::SideInset;
			%n7 = %west+$brickTes::SideInset SPC %north+$brickTes::SideDepth SPC %bottom+$brickTes::SideInset;

			%file.writeLine("----------------NORTHQUADS");
			%file.writeLine("5");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%n4);
			%file.writeLine(%n5);
			%file.writeLine(%n6);
			%file.writeLine(%n7);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 1 0");
			%file.writeLine("0 1 0");
			%file.writeLine("0 1 0");
			%file.writeLine("0 1 0");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%n5);
			%file.writeLine(%n1);
			%file.writeLine(%n2);
			%file.writeLine(%n6);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 0.6 0.4");
			%file.writeLine("0 0.6 0.4");
			%file.writeLine("0 0.6 0.4");
			%file.writeLine("0 0.6 0.4");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%n7);
			%file.writeLine(%n6);
			%file.writeLine(%n2);
			%file.writeLine(%n3);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("-0.4 0.6 0");
			%file.writeLine("-0.4 0.6 0");
			%file.writeLine("-0.4 0.6 0");
			%file.writeLine("-0.4 0.6 0");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%n0);
			%file.writeLine(%n4);
			%file.writeLine(%n7);
			%file.writeLine(%n3);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 0.6 -0.4");
			%file.writeLine("0 0.6 -0.4");
			%file.writeLine("0 0.6 -0.4");
			%file.writeLine("0 0.6 -0.4");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%n0);
			%file.writeLine(%n1);
			%file.writeLine(%n5);
			%file.writeLine(%n4);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0.4 0.6 0");
			%file.writeLine("0.4 0.6 0");
			%file.writeLine("0.4 0.6 0");
			%file.writeLine("0.4 0.6 0");

			%e0 = %east SPC %south SPC %bottom;
			%e1 = %east SPC %south SPC %top;
			%e2 = %east SPC %north SPC %top;
			%e3 = %east SPC %north SPC %bottom;
			%e4 = %east+$brickTes::SideDepth SPC %south+$brickTes::SideInset SPC %bottom+$brickTes::SideInset;
			%e5 = %east+$brickTes::SideDepth SPC %south+$brickTes::SideInset SPC %top-$brickTes::SideInset;
			%e6 = %east+$brickTes::SideDepth SPC %north-$brickTes::SideInset SPC %top-$brickTes::SideInset;
			%e7 = %east+$brickTes::SideDepth SPC %north-$brickTes::SideInset SPC %bottom+$brickTes::SideInset;

			%file.writeLine("----------------EASTQUADS");
			%file.writeLine("5");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%e4);
			%file.writeLine(%e5);
			%file.writeLine(%e6);
			%file.writeLine(%e7);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("1 0 0");
			%file.writeLine("1 0 0");
			%file.writeLine("1 0 0");
			%file.writeLine("1 0 0");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%e5);
			%file.writeLine(%e1);
			%file.writeLine(%e2);
			%file.writeLine(%e6);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0.6 0 0.4");
			%file.writeLine("0.6 0 0.4");
			%file.writeLine("0.6 0 0.4");
			%file.writeLine("0.6 0 0.4");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%e7);
			%file.writeLine(%e6);
			%file.writeLine(%e2);
			%file.writeLine(%e3);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0.6 0.4 0");
			%file.writeLine("0.6 0.4 0");
			%file.writeLine("0.6 0.4 0");
			%file.writeLine("0.6 0.4 0");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%e0);
			%file.writeLine(%e4);
			%file.writeLine(%e7);
			%file.writeLine(%e3);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0.6 0 -0.4");
			%file.writeLine("0.6 0 -0.4");
			%file.writeLine("0.6 0 -0.4");
			%file.writeLine("0.6 0 -0.4");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%e0);
			%file.writeLine(%e1);
			%file.writeLine(%e5);
			%file.writeLine(%e4);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0.6 -0.4 0");
			%file.writeLine("0.6 -0.4 0");
			%file.writeLine("0.6 -0.4 0");
			%file.writeLine("0.6 -0.4 0");

			%s0 = %west SPC %south SPC %bottom;
			%s1 = %west SPC %south SPC %top;
			%s2 = %east SPC %south SPC %top;
			%s3 = %east SPC %south SPC %bottom;
			%s4 = %west+$brickTes::SideInset SPC %south-$brickTes::SideDepth SPC %bottom+$brickTes::SideInset;
			%s5 = %west+$brickTes::SideInset SPC %south-$brickTes::SideDepth SPC %top-$brickTes::SideInset;
			%s6 = %east-$brickTes::SideInset SPC %south-$brickTes::SideDepth SPC %top-$brickTes::SideInset;
			%s7 = %east-$brickTes::SideInset SPC %south-$brickTes::SideDepth SPC %bottom+$brickTes::SideInset;

			%file.writeLine("----------------SOUTHQUADS");
			%file.writeLine("5");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%s4);
			%file.writeLine(%s5);
			%file.writeLine(%s6);
			%file.writeLine(%s7);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 -1 0");
			%file.writeLine("0 -1 0");
			%file.writeLine("0 -1 0");
			%file.writeLine("0 -1 0");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%s5);
			%file.writeLine(%s1);
			%file.writeLine(%s2);
			%file.writeLine(%s6);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 -0.6 0.4");
			%file.writeLine("0 -0.6 0.4");
			%file.writeLine("0 -0.6 0.4");
			%file.writeLine("0 -0.6 0.4");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%s7);
			%file.writeLine(%s6);
			%file.writeLine(%s2);
			%file.writeLine(%s3);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0.4 -0.6 0");
			%file.writeLine("0.4 -0.6 0");
			%file.writeLine("0.4 -0.6 0");
			%file.writeLine("0.4 -0.6 0");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%s0);
			%file.writeLine(%s4);
			%file.writeLine(%s7);
			%file.writeLine(%s3);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("0 -0.6 -0.4");
			%file.writeLine("0 -0.6 -0.4");
			%file.writeLine("0 -0.6 -0.4");
			%file.writeLine("0 -0.6 -0.4");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%s0);
			%file.writeLine(%s1);
			%file.writeLine(%s5);
			%file.writeLine(%s4);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("-0.4 -0.6 0");
			%file.writeLine("-0.4 -0.6 0");
			%file.writeLine("-0.4 -0.6 0");
			%file.writeLine("-0.4 -0.6 0");

			%w0 = %west SPC %north SPC %bottom;
			%w1 = %west SPC %north SPC %top;
			%w2 = %west SPC %south SPC %top;
			%w3 = %west SPC %south SPC %bottom;
			%w4 = %west-$brickTes::SideDepth SPC %north-$brickTes::SideInset SPC %bottom+$brickTes::SideInset;
			%w5 = %west-$brickTes::SideDepth SPC %north-$brickTes::SideInset SPC %top-$brickTes::SideInset;
			%w6 = %west-$brickTes::SideDepth SPC %south+$brickTes::SideInset SPC %top-$brickTes::SideInset;
			%w7 = %west-$brickTes::SideDepth SPC %south+$brickTes::SideInset SPC %bottom+$brickTes::SideInset;

			%file.writeLine("----------------WESTQUADS");
			%file.writeLine("5");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%w4);
			%file.writeLine(%w5);
			%file.writeLine(%w6);
			%file.writeLine(%w7);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("-1 0 0");
			%file.writeLine("-1 0 0");
			%file.writeLine("-1 0 0");
			%file.writeLine("-1 0 0");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%w5);
			%file.writeLine(%w1);
			%file.writeLine(%w2);
			%file.writeLine(%w6);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("-0.6 0 0.4");
			%file.writeLine("-0.6 0 0.4");
			%file.writeLine("-0.6 0 0.4");
			%file.writeLine("-0.6 0 0.4");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%w7);
			%file.writeLine(%w6);
			%file.writeLine(%w2);
			%file.writeLine(%w3);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("-0.6 -0.4 0");
			%file.writeLine("-0.6 -0.4 0");
			%file.writeLine("-0.6 -0.4 0");
			%file.writeLine("-0.6 -0.4 0");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%w0);
			%file.writeLine(%w4);
			%file.writeLine(%w7);
			%file.writeLine(%w3);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("-0.6 0 -0.4");
			%file.writeLine("-0.6 0 -0.4");
			%file.writeLine("-0.6 0 -0.4");
			%file.writeLine("-0.6 0 -0.4");
			%file.writeLine("");
			%file.writeLine("TEX:SIDE");
			%file.writeLine("POSITION:");
			%file.writeLine(%w0);
			%file.writeLine(%w1);
			%file.writeLine(%w5);
			%file.writeLine(%w4);
			%file.writeLine("UV COORDS:");
			%file.writeLine("0.8 0.2");
			%file.writeLine("0.8 0.8");
			%file.writeLine("0.2 0.8");
			%file.writeLine("0.2 0.2");
			%file.writeLine("NORMALS:");
			%file.writeLine("-0.6 0.4 0");
			%file.writeLine("-0.6 0.4 0");
			%file.writeLine("-0.6 0.4 0");
			%file.writeLine("-0.6 0.4 0");
	}
	%file.writeLine("----------------OMNIQUADS");
	%file.writeLine("0");
	%file.close();
	%file.delete();
}
generateTesBricks();